/****************************************************************
 *                                                              *
 * Man Kam Kwong  Mathematics and Computer Science Division     *
 *                =========================================     *
 *   12/18/94     Argonne National Laboratory                   *
 *                ===========================                   *
 *                                                              *
 * kwong@mcs.anl.gov                                            *
 *                                                              *
 * See the WEB pages "htxp - A Time-Saving Marco Tool for       *
 *                           HTML (and Other) Documents"        *
 *                                                              *
 *                    http://www.anl.gov/home/kwong/htxp.html   *
 * and                                                          *
 *                    http://www.anl.gov/home/kwong/hhelp.html  *
 *                                                              *
 *   for documentation                                          *
 *                                                              *
 * ============================================================ *
 *                                                              *
 * Source file for "hhelp", requires header file "magicxp.h".   *
 *                                                              *
 * Compile using "cc" or "gcc" in a UNIX environment.           *
 *                                                              *
 * ============================================================ *
 *                                                              *
 * The software is released to the public domain.  Feel free to *
 *   use it.  Suggestions for improvement and reports of bugs   *
 *   are appreciated.  If you come up with a better version of  *
 *   the program, I would appreciate a copy whenever possible.  *
 *                                                              *
 * DISCLAIMER: I am not responsible if all your files disappear *
 *             after using the software.                        *
 *                                                              *
 *             The code works but is far from being clean and   *
 *             well-documented (and I cannot find time to       *
 *             fine-tune it).                                   *
 *                                                              *
 ****************************************************************/

#include  "magicxp.h"
#undef   SKS
#define  SKS  W(isspace(*pt)) pt++
#define  SKW  W(*pt && !isspace(*pt)) pt++
#undef P
#define  P printf
 
void main(argc, argv)
int argc;
char *argv[];
{
int c, aflag=0, sflag=0, len, m1, M1, m2, M2, n1, n2, c1, c2,
     match, neof1, neof2, match1, match2, ucmsym;
FILE *fh, *fa, *fa1, *fa2, *fau, *farc;
char line[256], command[80], ans[256], topic[30], *pt, *pt2;
char line1[256], line2[256];
char vifile[80];
char lh[260], abb1[80], abb2[80], ucm[80], rc[80], 
     string1[10], string2[80];
 
  if (argc==1)  SC(line,""); E SC(line,argv[1]);
  SC2(lh,line,"hlp"); SC2(abb1,line,"ab1"); SC2(abb2,line,"ab2");
  SC2(ucm,line,"ucm"); SC2(rc,line,"rc");
if (!exist(lh)) { P("%s not found\n",lh); exit(1); }
  fh = fopen(lh,"r"); fa1 = fopen(abb1,"r"); 
  if (farc = fopen(rc,"r")) {
     for (m1 = 1; fgets(line,256,farc); m1++) 
         { if (!isspace(line[0]) && line[0]) B; } m1--;
     for (M1 = m1+2; fgets(line,256,farc); M1++) 
         { if (isspace(line[0]) && fnb(line)) B; } 
     for (m2 = M1+2; fgets(line,256,farc); M1++) 
         { if (!isspace(line[0]) && line[0]) B; } m2-=2;
     for (M2 = m2+2; fgets(line,256,farc); M2++) 
         { if (isspace(line[0]) && (ucmsym=fnb(line))) B; }
     }
  E { fa2 = fopen(abb2,"r");
      if (fau = fopen(ucm,"r")) 
         { W (fgets(line,256,fau)) { if (ucmsym=fnb(line)) B; } }
    }
  SC(vifile,"");
  if (argc > 2) { if (exist(argv[2])) { fa = fopen(argv[2],"r");
                                        sflag = 1; }}
  if (!access(lh,W_OK)) Sc2(vifile,lh," ");
if (sflag)
  if (!access(argv[2],W_OK)) Sc2(vifile,argv[2]," ");

P("\n      ********************************************************");
P("\n      *                                                      *");
P("\n      *        Welcome  to  the  hhelp  Help   Facility      *");
P("\n      *                         ---                          *");
P("\n      *              Commands:                               *");
P("\n      *                                                      *");
P("\n      *                 top      topic                       *");
P("\n      *                 *op      topic ...  (WILD CARD)      *");
P("\n      *                 +top     advanced topic              *");
if (!EQ2(vifile,""," "))
P("\n      *                 :        edit help file              *");
P("\n      *                 <CR>     quit                        *");
P("\n      *                                                      *");
P("\n      ********************************************************\n");
P("\n\n      Main help file is: %s\n",lh);
 
  if (sflag) P("     Supp. help file is: %s \n",argv[2]);
  W (1) {
    P("\n? ");
    gets(ans);
    pt=ans; if (*pt==0) exit(1);
    E { W(*pt) pt++; W(isspace(*--pt)); *++pt=0; pt=ans; SKS;
        if (EQ3(pt,"exit","","quit")) exit(1); 
        EL (strlen(pt)==1 && (farc != NULL || fa1 != NULL || fa2 != NULL)) 
       { aflag='/'; c = *pt; }
    EL (*pt == ucmsym) { aflag=']'; c = *(pt+1); }
    E { if (Eq2(*pt,'+','*')) aflag=*pt++;
            E aflag='t'; }
      }

if (EQ(pt,":")) { EX2("vi ",vifile); } E {
P("--------------------------------------------------------------------\n\n");
    if(aflag=='/' && farc != NULL) {
      if (fa1 != NULL) { rewind(fa1);
        W (fgets(line1,256,fa1)) { 
          if (Eq2(line1[0],c,toupper(c))) 
             { STN(line1); puts(line1); } } }
          neof1=neof2=1; n1=m1; n2=m2;
              W (neof1 || neof2) { match1=0; match2=0;
          if (neof1) { rewind(farc); D(c1,1,n1) fgets(line1,256,farc);
          for (c1++;c1<M1;c1++) { fgets(line1,256,farc);
                  if (Eq2(line1[0],c,toupper(c))) { match1=1; B; } }
          n1 = c1; neof1 = match1; }
                  if (neof1) { pt = line1; W (*pt!='\n') pt++; *pt=0; }
          E  SC(line1,""); Sc(line1,"                             ");
                  pt = line1; for (len=1;len<=20;pt++) len++; *pt=0;

          if (neof2) { rewind(farc); D(c2,1,n2) fgets(line2,256,farc);
          for (c2++;c2<M2;c2++) { fgets(line2,256,farc);
                  if (Eq2(line2[0],c,toupper(c))) { match2=1; B; } }
          n2 = c2; neof2 = match2; }
                  if (neof2) { pt = line2; W (*pt!='\n') pt++; *pt=0; }
                  E  SC(line2,"");
                  pt = line2; for (len=1;len<=40;pt++) len++; *pt=0;
                  if (line1[0]!=' '||line2[0]) P("%s   %s\n",line1,line2);
                  }
       }
    EL (aflag=='/') {
          if ( fa1 != NULL ) { rewind(fa1); neof1=1; } E neof1=0;
               if ( fa2 != NULL ) { rewind(fa2); neof2=1; } E neof2=0;
               W (neof1 || neof2) { match1=0; match2=0;
                  if (neof1) W ( fgets(line1,256,fa1) ) {
                    if (Eq2(line1[0],c,toupper(c))) { match1=1; B; } }
                    neof1 = match1;
                  if (neof1) {
                  pt = line1; W (*pt!='\n') pt++; *pt=0;
                  Sc(line1,"                             ");
                  pt = line1; for (len=1;len<=20;pt++) len++; *pt=0; }
                  E SC(line1,"                              ");
                  if (neof2) W ( fgets(line2,256,fa2) ) {
                    if (Eq2(line2[0],c,toupper(c))) { match2=1; B; } }
                    neof2 = match2;
                  if (neof2) {
                  pt = line2; W (*pt!='\n') pt++; *pt=0;
                  Sc(line2,"                             ");
                  pt = line2; for (len=1;len<=40;pt++) len++; *pt=0; }
                  E  SC(line2,"");
                  if (line1[0]!=' '||line2[0]) P("%s   %s\n",line1,line2);
                  }
       }
     EL (aflag==']') { if (farc != NULL) { rewind(farc);
          D(c1,1,M2+2) fgets(line,256,farc);
          W (fgets(line,256,farc)) if (Eq2(line[0],c,toupper(c)))
            { STN(line); line[50]=0; puts(line); } }
        EL (fau != NULL) { rewind(fau);
          W (fgets(line,256,fau)) if (Eq2(line[0],c,toupper(c)))
            { STN(line); line[50]=0; puts(line); } }
       }
     E {
      pt=ans; SKS; if (aflag=='*') pt++;
               SC(topic,pt); len=strlen(topic); 
      rewind(fh);
               W (fgets(line,80,fh)) {
                 if (line[0]==';') { match=0; pt = line; pt++;
                    W (*pt) { if (strncmp(pt,topic,len)==0) { match=1; B; }
                              E { if (aflag=='*') pt++; E SKW; SKS; } }
                    }
                 EL (match) P("%s",line);
                 }
if (sflag) {
      rewind(fa);
               W (fgets(line,80,fa)) {
                 if (line[0]==';') { match=0; pt = line; pt++;
                    W (*pt) { if (strncmp(pt,topic,len)==0) { match=1; B; }
                              E { if (aflag=='*') pt++; E SKW; SKS; } }
                    }
                 EL (match) P("%s",line);
                 }
}
}
    P("\n--------------------------------------------------------------------");
   }}
}
 
fnb(pt)
char *pt;
{  Sks; if (*pt == '\n') return(0); E return(*pt); }
