.TH htxp 1  11/9/1995
.SH NAME 
htxp - a preprocessor for HTML files  
.SH SYNOPSIS

 magigxp [help + macro defs] [source doc] > [html output]

 and

 hhelp [help file]

.SH DESCRIPTION

Htxp is a preprocessor that provides time-saving features for 
writing HTML files: by allowing the use of user-specified 
abbreviations, and built-in and user-definable macros. 

The program is a filter that generates a regular HTML file from 
a raw source file which is essentially an HTML file with 
abbreviations and macros replacing long strings.  There is built-in 
shorthand for the most common HTML tags, and a user can add 
abbreviations and macros (either in external files or in-line).

Regular HTML tags can still be used, so that none of the macros 
are mandatory.  You just use as many macros or abbreviations as 
you can remember.  This also allows you to use "htxp" to modify an
existing HTML file.


.SH ABBREVIATONS

Here are some brief explanations of the "htxp" commands:

  o  Dot commands (".ht", ".t", etc.) are built-in shorthand for 
     common HTML tags.  They are like NROFF commands, and must be 
     the first nonwhite character in a line.
  
  o  Two abbreviation lists are used to allow for more abbreviations.

     ";h", ";dc", etc. are user-defined abbreviations you make up
     yourself and store in a file called "html.ab1"
  
     "$em" is from a second similar list stored in "html.ab2"
  
  o  Additional abbreviations can be also be defined  "dynamically" 
     and added to the second list using the command ".ab ...".
  
  o  "]h", "]H", etc.  are user-defined macros, stored in a file
     "html.ucm".  Here we use them to define a header "environment".
     Similarly, "]rm" and "]Rm" give a remark "environment"
     for writing "REMARKS".  
  
     Such macros can also be added dynamically in the document.
  
  o  The symbols ";", "$", and "]" for requesting abbreviations
     and macros are changeable.

  o  See the on-line HTML manual for a fuller discussion of creating
     abbreviations and macros.


.SH AUTHOR

Man Kam Kwong:
kwong@mcs.anl.gov

http://www.mcs.anl.gov/home/kwong

Mathematics and Computer Science

Argonne National Laboratory
