/****************************************************************
 *                                                              *
 * Man Kam Kwong  Mathematics and Computer Science Division     *
 *                =========================================     *
 *    2/03/94     Argonne National Laboratory                   *
 *                ===========================                   *
 *                                                              *
 * kwong@mcs.anl.gov                                            *
 *                                                              *
 * See the WEB page "htxp - A Time-Saving Marco Tool for        *
 *                          HTML (and Other) Documents"         *
 *                                                              *
 *                   http://www.anl.gov/home/kwong/htxp.html    *
 * and                                                          *
 *                   http://www.anl.gov/home/kwong/hhelp.html   *
 *                                                              *
 *   for documentation                                          *
 *                                                              *
 * ============================================================ *
 *                                                              *
 * Source file for "magicxp", requires header file "magicxp.h". *
 *                                                              *
 * Compile using "cc" or "gcc" in a UNIX environment.           *
 *                                                              *
 * ============================================================ *
 *                                                              *
 * The software is released to the public domain.  Feel free to *
 *   use it.  Suggestions for improvement and reports of bugs   *
 *   are appreciated.  If you come up with a better version of  *
 *   the program, I would appreciate a copy whenever possible.  *
 *                                                              *
 * DISCLAIMER: I am not responsible if all your files disappear *
 *             after using the software.                        *
 *                                                              *
 *             The code works but is far from being clean and   *
 *             well-documented (and I cannot find time to       *
 *             fine-tune it).                                   *
 *                                                              *
 ****************************************************************/
 
#include "magicxp.h"
 
#define PT P("--%c--",*pt)
#define Cdw dpt2 = string; while(*dpt && *dpt!='_') *dpt2++ = *dpt++; *dpt2 = 0; if (*dpt) dpt++; sc(pt1,string); W (*pt1) pt1++
#define Oe  *dopt ==
 
int dlen, ulen, dcmsym='.', ucmsym=']', Esym,
     sym1=-1, sym2=-1, len1=0, len2=0;
int  bflag=0, pflag=0, vflag=0, wflag=0, xflag=1, xpflag=0, Eflag=0;
char ab1[MAX_NO_AB1][4], ab2[MAX_NO_AB2][4],
     sub1[MAX_NO_AB1][BUF_LEN], sub2[MAX_NO_AB2][BUF_LEN];
char abb1[40], abb2[40], usercom[40], dcmf[40], rc[40],
     input[40]="", root[40]="";
char line[BUF_LEN], line1[BUF_LEN], line2[BUF_LEN], 
     eol[80], EOL[80], word[80];
#ifdef MAGXP
char bcomment[40]="<!-- magxp", ecomment[40]=" -->";
#endif
 
FILE *fp;
 
void main(argc,argv)
int argc; char *argv[];
{
#ifdef MAGXP
char dcm[MAX_NO_CM][BUF_LEN];
#endif
char ucm[MAX_NO_CM][BUF_LEN];
   char *pt;
   int i, m;
 
   D(i,1,argc-1) { if (EQ(argv[i],"-")) xpflag = 1;
                 EL (argv[i][strlen(argv[i])-1]=='.') {
                    if (EQ(root,"")) SC(root,argv[i]); E B; }
                 E{ if (EQ(input,"")) SC(input,argv[i]); E B; }
               }
   if (!EQ(input,"") && !exist(input)) {
          printf("File not found: %s\n",input); exit(0); }
 
   SC(abb1,root); SC(abb2,root); SC(usercom,root); SC(rc,root);
   SC(dcmf,root);
   Sc(abb1,"ab1"); Sc(abb2,"ab2"); Sc(usercom,"ucm");
   Sc(rc,"rc"); Sc(dcmf,"dcm");
 
/*  DOT COMMANDS  */
 
#ifdef MAGXP
 if ((fp=fopen(dcmf,"r")) != NULL) {
   W ( !(i=fnb(line)) ) GL; dcmsym = i; 
   dlen = 0;
   W (GL) { if (fnb(line)) { if (dlen > 1 && isspace(line[0])) B;
            STN(line); SC(dcm[dlen++],line); } }
   } dlen--;
   W ( !(i=fnb(line)) ) GL; qsym = i;
   for (i=0; i<26 && (GL != NULL); ) { 
       if (fnb(line)) { STN(line); SC(uq[i],line); i++; } }
   for (i=0; i<26 && (GL != NULL); ) { 
       if (fnb(line)) { STN(line); SC(lq[i],line); i++; } }
   W (GL != NULL) { sscanf(line,"%s",word); STN(line);
       pt = line; Skw; Sks; if (*pt=='=') pt++; Sks;
       if (EQ(word,"bcomment")) SC(bcomment,pt);
       EL (EQ(word,"ecomment")) SC(ecomment,pt);
       }
   fclose(fp);
#else
 for (dlen=0; *dcm[dlen]; dlen++); dlen--;
#endif
 
 if ((fp=fopen(abb1,"r"))!=NULL){ GL; getabb(ab1,sub1,&sym1,&len1); }
    fclose(fp);
 if ((fp=fopen(rc,"r"))!=NULL) { GL; getabb(ab1,sub1,&sym1,&len1);
                            getabb(ab2,sub2,&sym2,&len2); }
 E{ 
    if ((fp=fopen(abb2,"r"))!=NULL){ GL; getabb(ab2,sub2,&sym2,&len2); }
    fclose(fp); fp=fopen(usercom,"r");
 }
 
/*  USER COMMANDS  */
 
 if (fp != NULL) {
   W ( !(i=fnb(line)) ) GL; ucmsym = i; pt = line; Sks; pt++; Sks;
   if (*pt && !isspace(*pt)) { SC2(ucm[0],"    ",pt); }
   E SC(ucm[0],"");
   ulen = 1;
   W (GL) { if (fnb(line)) { STN(line); SC(ucm[ulen++],line); } 
             E B; }
   W (GL != NULL) { sscanf(line,"%s",word); STN(line);
       pt = line; Skw; Sks; if (*pt=='=') pt++; Sks;
       if (EQ(word,"bcomment")) SC(bcomment,pt);
       EL (EQ(word,"ecomment")) SC(ecomment,pt);
       EL (EQ(word,"psspace")) psspace = *pt;
       EL (EQ(word,"dcmsym")) psspace = *pt;
       }
   } ulen--;
   fp = (EQ(input,"")) ? stdin : fopen(input,"r");

   W (GL != NULL) { 
                    xp(ucm,dcm); }
   fclose(fp);
}
 
xp(ucm,dcm)
char ucm[MAX_NO_CM][BUF_LEN];
char dcm[MAX_NO_CM][BUF_LEN];
{
char *pt, *pt1;
int i;

 STN(line);
 if (!fnb(line))  { if (!pflag && !xpflag & !vflag) { sc(line,ucm[0]); 
                       pflag = 1; } puts(line); }
 E  { pflag = 0;
 if (strstr(line,"NO XP")!=NULL) { puts(line); GL;
  STN(line); puts(line); }
 EL (strstr(line,"NO EXPANSION")!=NULL) { puts(line); GL;
  W (strstr(line,"RESUME EXPANSION")==NULL) {
    STN(line); puts(line); GL; }
  STN(line); puts(line); }
 E {
  SC(eol,"");
     
  if (xflag && vflag!=1 && Eflag && (index(line,Esym)!=NULL)) { 
        pt = line; pt1 = line1; W (*pt != Esym) *pt1++ = *pt++;
        *pt1 = 0; Sc(pt1,EOL); SC(EOL,""); Eflag = 0; pt++;
        W (*pt1) pt1++; pt++; W (*pt) *pt1++ = *pt++; *pt1 = 0; 
        SC(line,line1); }
  pt=line; Sks;
  if (*pt==dcmsym) { pt++;
     if (vflag) dot(dcm,dlen);
     EL (*pt == 'a') S (*(pt+1)) {
      C 'b' : pt+=2; Sks; ab2[len2][0] = *pt++;
              if (isspace(*pt)) ab2[len2][1]=0;
              E { ab2[len2][1] = *pt++; ab2[len2][2]=0; }
              Sks; SC(sub2[len2],pt);
              if (sym2==-1) sym2 = '$'; len2++;
              if (!xpflag) { SC3(line1,bcomment,line,ecomment);
              SC(line,line1); } B;
      C 'u' : pt+=2; Sks; SC(ucm[++ulen],pt);
              if (!xpflag) { SC3(line1,bcomment,line,ecomment);
              SC(line,line1); } B;
      C 'd' : pt+=2; Sks; dcmsym = *pt; if (!xpflag) return(0); B;
      C 'p' : pt+=2; Sks; psspace = *pt; if (!xpflag) return(0); B;
      C 'q' : pt+=2; Sks; qsym = *pt; if (!xpflag) return(0); B;
      C '1' : pt+=2; Sks; sym1 = *pt; if (!xpflag) return(0); B;
      C '2' : pt+=2; Sks; sym2 = *pt; if (!xpflag) return(0); B;
      DE      dot(dcm,dlen); B;
     }
     E dot(dcm,dlen);
  }
  if (*pt==ucmsym) { pt++; dot(ucm,ulen); }
  if (xflag && vflag!=1) { Sc(line,eol); 
                           strxp(line,line1); 
                         } 
  E { SC(line1,line); xflag = 1; }
  P("%s\n",line1); }
  }
}
 
find(c1,c2,ar,len)
char ar[MAX_NO_CM][BUF_LEN];
int c1, c2, len;
{
int n;
  if (isspace(c2)||c2==0) c2=' ';
  for (n=len; n>=0 && (c1!=ar[n][0] || c2!=ar[n][1]); n--);
  if (n<0) { c2=' ';
  for (n=len; n>=0 && (c1!=ar[n][0] || c2!=ar[n][1]); n--); }
  return(n);
}
 
dot(cm,len)
char cm[MAX_NO_CM][BUF_LEN];
int len;
{
char *pt, *pt1, *ptb, *dpt, *dpt2, string[BUF_LEN], beol[BUF_LEN];
int  i, n, delim=0;

  pt=line; pt1=line1; Cs; pt++;
  if (!*pt) { *pt = ' '; *(pt+1) = 0; }
  n = find(*pt,*(pt+1),cm,len);
  if (n>=0) { dpt=cm[n]; if (isspace(cm[n][0]));
     EL (isspace(cm[n][1])) { pt++; if (isspace(*pt)) pt++; }
     E  pt += 2;
     W(!isspace(*dpt)) dpt++; W(isspace(*dpt)) dpt++;
     if (*dpt == '-') {
       dpt++; W (!isspace(*dpt)) {
         S(*dpt++) {
           C 'v': if (vflag!=1) vflag = 2; B;
           C 'V': vflag = 0; B;
           C 'x': if (!vflag) xflag = 0; B;
     } } }
     W (isspace(*dpt)) dpt++;
     if (vflag == 2) { Cdw; A(pt); vflag = 1; }
     EL (vflag) { SC(line1,line); }
     EL (xflag) {
       if (!(isspace(*pt)||*pt==0)) { 
        if ((*pt=='{' || isalnum(*pt)) && index(pt,'{') != NULL) {
          ptb=pt; W (*ptb != '{') ptb++; bflag = 1; ptb++;
          W (*ptb) { if (*ptb == '{') bflag++; EL (*ptb == '}') bflag--;
            ptb++; 
            if (!bflag) { SC(beol,ptb); 
            *(--ptb)=0; bflag = 1; B; } } }
        EL (!(isalnum(*pt) || Eq3(*pt,qsym,psspace,'\"') || Eq4(*pt,dcmsym,ucmsym,sym1,sym2))) { Eflag=2; Esym = *pt++; }
       }
          if (bflag) { 
                       W (*pt != '{') *pt1++ = *pt++; pt++; }
          if (Eflag==2 && (index(pt,Esym)!=NULL)) { 
                       W (*pt != Esym) *pt1++ = *pt++; pt++; }
     W (*dpt) {
       Cdw; W (*pt1) pt1++; 
         W (isspace(*pt)) pt++;

       if (wflag) { 
         W (*pt && *pt != psspace && !isspace(*pt) && (Eflag!=2 || *pt!=Esym)) *pt1++ = *pt++;
         SC(pt1,word); W(*pt1) pt1++; 
         W (*pt && !isspace(*pt)) { 
           if (*pt == psspace) { *pt1++ = ' '; pt++; }
           E *pt1++ = *pt++; }
         if (isspace(*pt)) pt++;
         wflag = 0;  }
       EL(*dpt!='_') { W(*pt && !isspace(*pt) && (Eflag!=2 || *pt!=Esym)) *pt1++ = *pt++; }
       if (*dpt=='_') { dpt++; if (Eflag==2) { sc(EOL,dpt); }
                               E sc(eol,dpt); B; } 
     }
       if (Eflag==2 && (index(pt,Esym)!=NULL)) { W (*pt != Esym)
          *pt1++ = *pt++; *pt1 = 0; Sc(pt1,EOL); SC(EOL,"");
          Eflag = 0; pt++; }
       EL (Eflag==2) Eflag=1;
       E  A(pt);
       if (bflag) { Sc(eol,beol); 
                    bflag = 0;}
     }
     E { Cdw; A(pt); puts(line1); GL; STN(line); }
  }
  E SC(line1,line);
  if (!xpflag && xflag && vflag!=2) SC(line,line1); E { SC(EOL,""); SC(eol,""); Eflag =0; }
}
 
strxp(string1,string2)
char string1[], string2[];
{  char *pt1, *pt2;
   int d;
   pt1=string1; pt2=string2; *pt2=0; 
 while (*pt1)
   { 
    d= *(pt1+1); while (*pt2) pt2++;
 
/*  ABBREVIATION EXPANSION  */
     if (*pt1==sym1 && !isspace(d) && d)
        pt1=pt1+locate(pt1,pt2,ab1,sym1,len1,sub1);
     EL (*pt1==sym2 && !isspace(d) && d)
{
        pt1=pt1+locate(pt1,pt2,ab2,sym2,len2,sub2);
}
     EL (*pt1=='\\') { *pt2++ = *pt1++; *pt2++ = *pt1++; *pt2=0;; }
     EL (*pt1==qsym && !xpflag) { pt1++; if (isalpha(*pt1)) { *pt2=0;
        if (islower(*pt1))  Sc(pt2,lq[*pt1 - 'a']);
        E                  Sc(pt2,uq[*pt1 - 'A']); 
        W (*pt2) pt2++; pt1++; } E { *pt2++ = qsym; *pt2=0; } }
     E { *pt2++ = *pt1++; *pt2=0; }; 
 }
}
 
locate(pt1,pt2,pattern,Sym,Len,sub)
char *pt1, *pt2;
char pattern[][4], sub[][BUF_LEN];
int Sym, Len;
{
   int n=Len, cflag=1, shift=3;
   char *pt, pat[4];
   if (*(pt1+1)==Sym) { cflag=0; pt1++; } pt1++;
   pat[0]= *pt1; pat[1]= *(pt1+1); pat[2]=0;
   if (pat[1]) while ( n>=0 && strcmp(pat,pattern[n]) ) n--;
   E  n = -1;
   if (n<0)  { pat[1]=0; 
      for ( n=Len; ( n>=0 && strcmp(pat,pattern[n]) ); n-- );
      shift = (n>=0)? 2 : 1; 
      }
   if (n>=0) { pt = sub[n]; if (cflag==0) { if (isalpha(*pt)) {
                   *pt2++ = (islower(*pt))?toupper(*pt):tolower(*pt);
                   sc(pt2,pt+1); }
                   E sc(pt2,pt); shift++; }
               E   sc(pt2,pt);
     if (wflag) shift--;
     W (wflag) { 
       if (pat[1]) pt1++; shift++; pt1++; shift++; 
       W (*pt2) pt2++; 
       if (isspace(*pt1)) { pt1++; shift++; }
       W (*pt1 && isspace(*pt1)) { *pt2++ = *pt1++; shift++; }
       if (Eq2(wflag,2,3)) 
          W (*pt1 && !isspace(*pt1)) { 
            if (wflag == 2) { *pt2++ = *pt1++; shift++; }
            E { if (*pt1 == psspace) { 
                   if (*(pt1+1) == psspace) { pt1++; *pt2++ = *pt1++; shift+=2; }
                   E { *pt2++ = ' '; pt1++; *pt2++ = *pt1++; shift+=2; } }
                E  { *pt2++ = *pt1++; shift++; }
              }
          }
       E { W (*pt1 && !isalnum(*pt1)) { *pt2++ = *pt1++; shift++; }
           W (*pt1 && isalnum(*pt1)) { *pt2++ = *pt1++; shift++; }
           if (!isspace(*pt1)) { pt1--; shift--; }
         }
       wflag = 0; 
       sc(pt2,word); 
       W(*pt2) pt2++;
     }
       }
   E { if (n<0) { *pt2++=Sym; if (cflag==0) { *pt2++=Sym;
                                       *pt2=0; shift++; }
                              E  *pt2=0; } }
   return(shift);
}
 
getabb(pattern,sub,SYM,LEN)
int *SYM, *LEN;
char pattern[][4], sub[][BUF_LEN];
{
   int l;
   char *pt;
 
   W (!(l=fnb(line))) { GL; }; *SYM = l;
   for (l=*LEN; GL; l++ )
     { pt=line; STN(line);
       if (SP || !*pt) { Sks; if (*pt) B; E l--; continue; }
       E{ pattern[l][0] = *pt++;
          if (SP) pattern[l][1] = 0;
          E { pattern[l][1] = *pt++; pattern[l][2] = 0; }
          Sks; SC(sub[l],pt); } }
   *LEN = l;
}
 
sc(pt2,pt)
char *pt2, *pt;
{
char num[5], *pnum;
int  i, n;
  W (*pt) { if (*pt == '\\') { pt++; 
             if (isdigit(*pt)) { pnum = num; 
                W (isdigit(*pt)) *pnum++ = *pt++; *pnum = 0;
                sscanf(num,"%i",&n); D(i,1,n) *pt2++ = *pt; pt++; }
             E {
               S(*pt) {
               C 'n': *pt2++ = '\n'; pt++; B;
               C 'w': *pt2 = 0; wflag=1; SC(word,pt+1); return(0); B;
               C 'W': *pt2 = 0; wflag=2; SC(word,pt+1); return(0); B;
               C 'c': *pt2 = 0; wflag=3; SC(word,pt+1); return(0); B;
               DE     *pt2++ = *pt++; B;  } } }
            E  *pt2++ = *pt++;
          }
  *pt2 = 0;
}
 
fnb(pt)
char *pt;
{  Sks; if (*pt == '\n') return(0); E return(*pt); }

