/****************************************************************
 *                                                              *
 * Man Kam Kwong  Mathematics and Computer Science Division     *
 *                =========================================     *
 *   12/22/94     Argonne National Laboratory                   *
 *                ===========================                   *
 *                                                              *
 * kwong@mcs.anl.gov                                            *
 *                                                              *
 * See the WEB page "htxp - A Time-Saving Marco Tool for        *
 *                          HTML (and Other) Documents"         *
 *                                                              *
 *                   http://www.anl.gov/home/kwong/htxp.html    *
 * and                                                          *
 *                   http://www.anl.gov/home/kwong/hhelp.html   *
 *                                                              *
 *   for documentation                                          *
 *                                                              *
 * ============================================================ *
 *                                                              *
 * Header file accompanying "magicxp" and "hhelp"               *
 *                                                              *
 * Compile using "cc" or "gcc" in a UNIX environment.           *
 *                                                              *
 * ============================================================ *
 *                                                              *
 * The software is released to the public domain.  Feel free to *
 *   use it.  Suggestions for improvement and reports of bugs   *
 *   are appreciated.  If you come up with a better version of  *
 *   the program, I would appreciate a copy whenever possible.  *
 *                                                              *
 * DISCLAIMER: I am not responsible if all your files disappear *
 *             after using the software.                        *
 *                                                              *
 *             The code works but is far from being clean and   *
 *             well-documented (and I cannot find time to       *
 *             fine-tune it).                                   *
 *                                                              *
 ****************************************************************/
#include  <stdio.h>
#include  <ctype.h>
/****
#define IBMPC
*****/
#ifndef IBMPC
#      include  <sys/file.h>
#include  <strings.h>
#      define exist(f) !access(f,F_OK)
#      define executable(f) !access(f,X_OK)
#      define readable(f) !access(f,R_OK)
#      define writable(f) !access(f,W_OK)
#define MAX_NO_AB1 400
#define MAX_NO_AB2 200
#define MAX_NO_CM  300
#define BUF_LEN 256
#else
#      include  <io.h>
#      define exist(f) !access(f,0)
#      define index strchr
#define MAX_NO_AB1 200
#define MAX_NO_AB2 100
#define MAX_NO_CM  100
#define BUF_LEN 120
#endif
 
#define GL fgets(line,BUF_LEN,fp)
#define B break
#define C case
#define D(i,m,n)  for(i=m;i<=n;i++)
#define DE default :
#define E else 
#define EL else if
#define EQ(x,y) (strcmp(x,y)==0)
#define EQ2(x,y,z) (EQ(x,y)||EQ(x,z))
#define EQ3(x,y,z,u) (EQ(x,y)||EQ2(x,z,u))
#define EQ4(x,y,z,u,v) (EQ(x,y)||EQ3(x,z,u,v))
#define EX2(x,y) {SC2(command,x,y);SYS(command);}
#define EX3(x,y,z) {SC3(command,x,y,z);SYS(command);}
#define EX4(x,y,z,v) {SC4(command,x,y,z,v); SYS(command);}
#define EX5(x,y,z,v,w) {SC5(command,x,y,z,v,w);SYS(command);}
#define Eq2(x,y,z) (x==y||x==z)
#define Eq3(x,y,z,u) (x==y||Eq2(x,z,u))
#define Eq4(x,y,z,u,v) (x==y||Eq3(x,z,u,v))
#define G(x) printf(x); gets(line)
#define GC (d=getc(fp))
#define GT(x,y) (strcmp(x,y)>0)
#define Gc (c=getc(fp))
#define Gl fgets(line,40,fp)
#define Next(x,y) {while (*y==' ') y++; while(*y && *y!=' ') *x++ = *y++; *x=0;}
#define FP fflush(stdout)
#define S switch
#define SC strcpy
#define SC2(s,x,y) {SC(s,x);Sc(s,y);}
#define SC3(s,x,y,z) {SC(s,x);Sc2(s,y,z);}
#define SC4(s,x,y,z,v) {SC(s,x);Sc3(s,y,z,v);}
#define SC5(s,x,y,z,v,w) {SC(s,x);Sc4(s,y,z,v,w);}
#define SKS while ((d=getc(fp))==' '||d=='\t'); c=' ';
#define SYS(x) system(x)
#define Sc strcat
#define Sc2(s,x,y) {Sc(s,x);Sc(s,y);}
#define Sc3(s,x,y,z) {Sc(s,x);Sc2(s,y,z);}
#define Sc4(s,x,y,z,v) {Sc(s,x);Sc3(s,y,z,v);}
#define Sc5(s,x,y,z,v,w) {Sc(s,x);Sc4(s,y,z,v,w);}
#define UG ungetc(d,fp)
#define W while
 
#define PC putchar
#define P printf
 
#define Cs while (SP) *pt1++ = *pt++
#define SP isspace(*pt)
#define NSP *pt&&!isspace(*pt)
#define Sts pt2=line+strlen(line); W(isspace(*pt2--)); *++pt2=0
#define Sks while (SP) pt++
#define Skw while (NSP) pt++; Sks
#define Pc *pt1++ =
#define Cw Sks; while (NSP) *pt1++ = *pt++
#define CW(s) Sks; pt2=s; while (NSP) *pt2++ = *pt++; *pt2=0
#define End W(*pt1++); pt1 -= 1
#define A(s) *pt1=0; Sc(pt1,s); End
#define AB(s) A(s); B
#define A2(s,t) *pt1=0; Sc2(pt1,s,t); End
#define A2B(s,t) A2(s,t); B
#define A3(s,t,u) *pt1=0; Sc3(pt1,s,t,u); End
#define A4(s,t,u,v) *pt1=0; Sc4(pt1,s,t,u,v); End
#define ADD(s,t) A(s); Sc(eol,t)
#define Add(s,t) ADD(s,t); B
#define Br BR B
#define Sp switch(*pt++)
#define CPL A(line); *pt=0
#define STN(x)  if (x[strlen(x)-1]=='\n') x[strlen(x)-1] = 0
 
int qsym = '?', psspace = ',';

#ifndef MAGXP
char bcomment[]="<!-- htxp ", ecomment[]=" -->";
static char dcm[120][BUF_LEN] = {
  "    <li> ",
  "./  </li> ",
  "-   <hr>",
  "hr  <hr>",
  "a   <a href=\"\\w\"_>__</a>",
  "ah  <a href=\"http:\\w\"_>__</a>",
  "aF  <a href=\"file:\\w\"_>__</a>",
  "ag  <a href=\"gopher:\\w\"_>__</a>",
  "an  <a href=\"news:\\w\"_>__</a>",
  "at  <a href=\"telnet:\\w\"_>__</a>",
  "af  <a href=\"ftp:\\w\"_>__</a>",
  "n   <a name=\"_\">__</a>",
  "na  <a name=\"_\" href=\"\\w\"_>__</a>",
  "nh  <a name=\"_\" href=\"http:\\w\"_>__</a>",
  "nF  <a name=\"_\" href=\"file:\\w\"_>__</a>",
  "ng  <a name=\"_\" href=\"gopher:\\w\"_>__</a>",
  "nn  <a name=\"_\" href=\"news:\\w\"_>__</a>",
  "nt  <a name=\"_\" href=\"telnet:\\w\"_>__</a>",
  "nf  <a name=\"_\" href=\"ftp:\\w\"_>__</a>",
  "b   <body>",
  "B   </body>",
  "cm  <!-- ",
  "Cm  \\1 --> ",
  "!   <!-- __ -->",
  "h   <head>",
  "H   </head>",
  "ht  <html>",
  "Ht  </html>",
  "h1  <h1>",
  "H1  </h1>",
  "h2  <h2>",
  "H2  </h2>",
  "h3  <h3>",
  "H3  </h3>",
  "h4  <h4>",
  "H4  </h4>",
  "h5  <h5>",
  "H5  </h5>",
  "h6  <h6>",
  "H6  </h6>",
  "1   <h1>__</h1>",
  "2   <h2>__</h2>",
  "3   <h3>__</h3>",
  "4   <h4>__</h4>",
  "5   <h5>__</h5>",
  "6   <h6>__</h6>",
  "lk  <link rev=\"made\" href=\"mailto:__\">",
  "em  <em>__</em>",
  "st  <strong>__</strong>",
  "it  <i>__</i>",
  "bf  <b>__</b>",
  "ul  <u>__</u>",
  "kb  <kbd>__</kbd>",
  "ky  <key>__</key>",
  "tt  <tt>__</tt>",
  "sm  <samp>__</samp>",
  "vr  <var>__</var>",
  "df  <dfn>__</dfn>",
  "ct  <cite>__</cite>",
  "ad  <address>",
  "Ad  </address>",
  "bq  <blockquote>",
  "Bq  </blockquote>",
  "q   <blockquote>",
  "Q   </blockquote>",
  "co -v <code>",
  "Co -V </code>",
  "xm -v <xmp>",
  "Xm -V </xmp>",
  "pr -v <pre>",
  "Pr -V </pre>",
  "ls -v <listing>",
  "Ls -V </listing>",
  "d   <dl>",
  "D   </dl>",
  ".   <dt>__</dt>",
  "dd  <dd>",
  "Dd  </dd>",
  "o   <ol>",
  "oc  <ol compact>",
  "O   </ol>",
  "p   <p>",
  "P   </p>",
  "u   <ul>",
  "uc  <ul compact>",
  "U   </ul>",
  "l   <br>",
  "br  <br>",
  "c   <center>",
  "C   </center>",
  "i   <img src=\"\\w\"_>",
  "iT  <img align=\"top\" src=\"\\w\"_>",
  "iM  <img align=\"middle\" src=\"\\w\"_>",
  "iB  <img align=\"bottom\" src=\"\\w\"_>",
  "ic  <inc srv \"\\w\"_>",
  "t   <title>__</title>",
  "ii  <isindex>",
  "im  <ismap>",
  "v -v   \\40 <!-- NO EXPANSION -->",
  "V -V   \\40 <!-- RESUME EXPANSION -->",
  "nx -x  \\40 <!-- NO XP NEXT LINE -->",
};
static char uq[26][40] =
  { "?A", "?B", "?C", "?D", "?E", 
    "?F", "?G", "?H", "?I", "?J", 
    "?K", "?L", "?M", "?N", "?O",
    "?P", "?Q", "?R", "?S", "?T", 
    "?U", "?V", "?W", "?X", "?Y", 
    "?Z" };
  static char lq[26][40] =
  { "alt=\"\"", "align=\"bottom\"", "align=\"center\"", "?d", "?e", 
    "?f", "?g", "?h", "?i", "?j", 
    "?k", "align=\"left\"", "align=\"middle\"", "?n", "?o", 
    "?p", "?q", "aliagn=\"right\"", "?s", "algin=\"top\"", 
    "?u", "?v", 
    "?w", "?x", "?y", "?z" };
#else
char uq[26][40], lq[26][40];
#endif
